/*	gui.h  contains various useful graphics functions */
/*	for drawing the user interface 			  */

// switch DISPLAY_SCREEN - 1 is Looper, 2 is File Load
void switch_screen(int S);

// draws static components of user interface //
void draw_static_screen1();
void draw_static_screen2();
void draw_static_screen3();
void draw_static_screen4();

// handles keyboard events //
void handle_keyboard_screen1();
void handle_keyboard_screen2();
void handle_keyboard_screen3();
void handle_keyboard_screen4();

int get_bpm();
int set_bpm(int B);
void draw_vu_bar(int V, int X, int Y, int Dir);
void draw_bpm_meter(int BPM, int ticks, int X, int Y);
void draw_vu(int L, int R);
void draw_loop_parameters(int L);

void draw_oscilloscope(int L, int X, int Y);

void blue_frame_ch(int X1, int Y1, int X2, int Y2);
void active_frame_ch(int X1, int Y1, int X2, int Y2);

void blue_frame_xy(int X1, int Y1, int X2, int Y2);

void box_xy(int X1, int Y1, int X2, int Y2, int Col);

void refresh_mouse_spinners ();
void refresh_parm_boxes_scr1();
void update_parm_boxes_scr1();
void refresh_efx_parms_scr3();
void update_efx_parms_scr3();

void set_test_efx_wires_scr3(); // for debugging only!
void draw_efx_wires_scr3();

void clear_curr_effect_scr3();

// VU meter color settings
#define YEL_VU 50
#define ORG_VU 80
#define RED_VU 110

// position of loop title bar
#define LB_X 1
#define LB_Y 4

// bpm controller
#define BP_X 1
#define BP_Y 28

// load/save layout
#define LS_X 15
#define LS_Y 28

// cursor
#define SCR_1_CURX 9
#define SCR_1_CURY NUM_LOOPS+2

// mouse controls
#define NUM_MOUSE_SPINNERS 8
#define MOUSE_SPINNERS_X 0
#define MOUSE_SPINNERS_Y 49
#define MOUSE_SPINNER_WIDTH 10
#define MOUSE_SPINNER_HEIGHT 10









