////////////////////////////////////////////////////////////////////////////////////////////////////////////
////	effects screen /////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgakeyboard.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include "CharMap.h"
#include "loopdata.h"
#include "input.h"
#include "gui.h"
#include "pump.h"
#define INIT_GLOBALS
#include "fxdata.h"
#include "fxbmp.h"

#define FX_TOP 4
#define FX_LEFT 4
#define FX_WIDTH 6
#define FX_CNTRL_LEFT FX_WIDTH*(1+FX_ROW) + FX_LEFT + 3

#define FX_MESSAGE_X 5
#define FX_MESSAGE_Y 45

int fx_wire = 0;
int fx_wire_col = 0;
int fx_wire_loop = 0;
int fx_wire_term = 0;



int SCR3_CURX = 0;
int SCR3_CURY = 0;

#define SCR3_MAXX FX_ROW + 3
#define SCR3_MAXY NUM_LOOPS + 1

void draw_fx (int Type, int X, int Y, char * Label);
void draw_fx_bmp (int Char, int X, int Y);
void erase_left_stuff_scr3();

//	effect parameter window	//
static effect_stat * curr_effect = NULL;
static int curr_effect_col = -1;
static int curr_effect_loop = -1;

void clear_curr_effect_scr3()
{
	curr_effect = NULL;
	curr_effect_col = -1;
	curr_effect_loop = -1;
}

void set_curr_effect (int Col, int Loop);
void draw_eff_boxes();

//	navigation functions //
void leave_scr3_box(int x, int y);
void enter_scr3_box(int x, int y);
void adjust_box_scr3(int x, int y, int delta);
void link_parm_box_scr3(int x, int y, int f);

//	tell user modal information //
void draw_fx_message(int nMesg);

void draw_fx_info();

//	do wiring modifications	//
void try_wire_from(int Loop, int Col, int Term);
void try_wire_to(int Loop, int Col, int Term);

//	draws the effect for a position in the effect grid //
void draw_effect (int Col, int Loop);

//	highlights a particular effect	//
void cursor_effect (int Col, int Loop);

//	red mark for wiring-from state  //
void red_mark	(int Col, int Loop, int Term);



void draw_static_screen3()
{
	int i, j;
	// mouse spinners frames
	for (i=0;i<NUM_MOUSE_SPINNERS;i++)
	{
	blue_frame_ch(MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+1,
			MOUSE_SPINNERS_Y,
		      MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*(i+1)-2,
			MOUSE_SPINNERS_Y+MOUSE_SPINNER_HEIGHT-1);
/*
	DrawStr("0000", MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+3,
			MOUSE_SPINNERS_Y, 0x80);
	DrawStr("NONE", MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+3,
			MOUSE_SPINNERS_Y+2, 0x80);
*/
	blue_frame_ch(MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+1,
			MOUSE_SPINNERS_Y-2,
		      MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*(i+1)-2,
			MOUSE_SPINNERS_Y-2);
	DrawAscChar('F', MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+4,
			MOUSE_SPINNERS_Y-2, 0x80);
	DrawAscChar('1'+i, MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+5,
			MOUSE_SPINNERS_Y-2, 0x80);
	}	
	for (i=0;i<NUM_LOOPS;i++)
	{
		DrawAscChar('A'+i, FX_LEFT-2, FX_TOP+4*i, 0x80);
		DrawChar('Q', FX_LEFT-1, FX_TOP+4*i, 0xE0);
		blue_frame_ch(FX_LEFT-2, FX_TOP+4*i, FX_LEFT-1, FX_TOP+4*i);
		DrawChar('Q', FX_LEFT+FX_WIDTH*(1+FX_ROW), FX_TOP+4*i, 0xE0);
		DrawAscChar('A'+i, FX_LEFT+1+FX_WIDTH*(1+FX_ROW), FX_TOP+4*i, 0x80);
		blue_frame_ch(FX_LEFT+FX_WIDTH*(1+FX_ROW), FX_TOP+4*i, 
				FX_LEFT+1+FX_WIDTH*(1+FX_ROW), FX_TOP+4*i);
	}

	for (i=0;i<NUM_LOOPS;i++)
		for (j=0;j<FX_ROW;j++)
			draw_effect(j, i);
	enter_scr3_box(SCR3_CURX, SCR3_CURY);
	blue_frame_ch(FX_CNTRL_LEFT, FX_TOP, 78, FX_TOP+NUM_LOOPS*4);
	if (curr_effect_col >= 0 && curr_effect_loop >= 0)
		set_curr_effect(curr_effect_col, curr_effect_loop);
	draw_eff_boxes();	
	//set_test_efx_wires_scr3();
	draw_efx_wires_scr3();
	draw_fx_info();
	if (fx_wire) red_mark(fx_wire_col, fx_wire_loop, fx_wire_term);

}



void handle_keyboard_screen3()
{
	int oldx, oldy, curmove, newx, newy, i;
	curmove = 0; oldx = newx = SCR3_CURX; oldy = newy = SCR3_CURY;
	if (is_pushed(SCANCODE_TAB)) 
	{
		switch_screen(1); 
		return;
	}
	if (is_pushed(SCANCODE_BACKSPACE))
	{
		if ((oldx < FX_ROW+1) && (oldy < NUM_LOOPS)) 
			if (oldx > 0)
			{
				fx_remove(oldx-1, oldy);
				fx_disconnect_all(oldx-1, oldy);
				if (curr_effect_col >= 0 && curr_effect_loop >= 0)
					set_curr_effect(curr_effect_col, curr_effect_loop);
			}
		leave_scr3_box(oldx,oldy);
		enter_scr3_box(oldx,oldy); // force repainting //
		return;
	}
	if (is_pushed(SCANCODE_ENTER))
		if ( ( (oldx > 0) && (oldx < FX_ROW+1)) && (oldy < NUM_LOOPS) )
			set_curr_effect (oldx-1, oldy);		
	
	if ( (is_pushed(SCANCODE_1) || is_pushed(SCANCODE_KEYPAD1)) || is_pushed(SCANCODE_SPACE) )
	{
		if (fx_wire == 0)
		{
			try_wire_from(oldy, oldx-1, 0);
			draw_fx_info();
			return;
		}
		else
		{
			try_wire_to(oldy, oldx-1, 0);
			// force repaint
			leave_scr3_box(1, 1);
			enter_scr3_box(oldx, oldy);
			draw_fx_info();
			return;
		}
		
	}
	if (is_pushed(SCANCODE_2) || is_pushed(SCANCODE_KEYPAD2))
	{
		if (fx_wire == 0)
		{
			try_wire_from(oldy, oldx-1, 1);
			draw_fx_info();
			return;
		}
		else
		{
			try_wire_to(oldy, oldx-1, 1);
			// force repaint
			leave_scr3_box(1, 1);
			enter_scr3_box(oldx, oldy);
			draw_fx_info();
			return;
		}
		
	}
	
	for (i = SCANCODE_F1; i < SCANCODE_F10; i++)
		if (is_pushed(i)) link_parm_box_scr3(oldx, oldy, i);
	
		
		
	if (is_pushed(SCANCODE_INSERT)) {adjust_box_scr3(oldx, oldy, 10);}
	if (is_pushed(SCANCODE_REMOVE))  
		{adjust_box_scr3(oldx,oldy,-10);}
	if (is_pushed(SCANCODE_PAGEUP)) {adjust_box_scr3(oldx, oldy, 1);}
	if (is_pushed(SCANCODE_PAGEDOWN)) {adjust_box_scr3(oldx, oldy, -1);}
	if (is_pushed(SCANCODE_CURSORBLOCKLEFT)) {newx--; curmove++;}
	if (is_pushed(SCANCODE_CURSORBLOCKRIGHT)){newx++; curmove++;}
	if (is_pushed(SCANCODE_CURSORBLOCKUP))	 {newy--; curmove++;}
	if (is_pushed(SCANCODE_CURSORBLOCKDOWN)) {newy++; curmove++;}
	if (curmove != 0)
	{
		if (newx < 0) newx = 0;
		if (newy < 0) newy = 0;
		if (newx >= SCR3_MAXX) 
			newx = SCR3_MAXX-1;
		if (newy >= SCR3_MAXY) 
			newy = SCR3_MAXY-1;
		leave_scr3_box(oldx, oldy);
		enter_scr3_box(newx, newy);
		SCR3_CURX = newx;
		SCR3_CURY = newy;
	}
	 
}


void leave_scr3_box(int x, int y)
{
	int i, j, left, right, top;
	
	if (y < NUM_LOOPS)
	{
		// loop in/out points
		if ( (x == 0) || (x == FX_ROW+1))
		{
			blue_frame_ch( (x==0)?FX_LEFT-2:FX_LEFT+FX_WIDTH*(1+FX_ROW),
				FX_TOP+4*y,
					 (x==0)?FX_LEFT-1:FX_LEFT+1+FX_WIDTH*(1+FX_ROW),
				FX_TOP+4*y);
			return;
		}
		else
		// effect schematic
		if (x < FX_ROW + 1&& y < NUM_LOOPS)
			if (x > 0)
		{
		for (i=0;i<FX_ROW;i++)
			for (j=0;j<NUM_LOOPS;j++)
				draw_effect(i,j);
		erase_left_stuff_scr3();
		draw_efx_wires_scr3();
		if (fx_wire)
			red_mark(fx_wire_col, fx_wire_loop, fx_wire_term);
		}
	}
	// effect parameters
	if (y < NUM_LOOPS && x == FX_ROW + 2)
	{
		if (y > 3) y = 3; // deal with extra
		blue_frame_ch(FX_CNTRL_LEFT+2, FX_TOP + 6 + 4*y, FX_CNTRL_LEFT + 5,
				FX_TOP + 6 + 4*y);
		return; 
	}
	
	// mouse spinners
	if (y == NUM_LOOPS)
	{
		if (x>7) x=7; // deal with extra box
		left = MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*x+1;
		right = MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*(x+1)-2;
		top = MOUSE_SPINNERS_Y-2;
		blue_frame_ch(left,top,right,top);
		return;
	}
}

void enter_scr3_box(int x, int y)
{
	int left, right, top;
	if ((x < FX_ROW + 1) && y < NUM_LOOPS)
		if (x > 0)
		{cursor_effect(x-1, y);	return;}
	if (y < NUM_LOOPS)
		if ( (x == 0) || (x == FX_ROW+1))
		{
			active_frame_ch( (x==0)?FX_LEFT-2:FX_LEFT+FX_WIDTH*(1+FX_ROW),
				FX_TOP+4*y,
					 (x==0)?FX_LEFT-1:FX_LEFT+1+FX_WIDTH*(1+FX_ROW),
				FX_TOP+4*y);
			return;
		}
	// effect parameters
	if (y < NUM_LOOPS && x == FX_ROW + 2)
	{
		if (y > 3) y = 3; // deal with extra
		active_frame_ch(FX_CNTRL_LEFT+2, FX_TOP + 6 + 4*y, FX_CNTRL_LEFT + 5,
				FX_TOP + 6 + 4*y);
		return; 
	}
	
	// mouse spinners
	if (y == NUM_LOOPS)
	{
		if (x>7) x=7; // deal with extra box
		left = MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*x+1;
		right = MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*(x+1)-2;
		top = MOUSE_SPINNERS_Y-2;
		active_frame_ch(left,top,right,top);
		return;
	}
	
}

void adjust_box_scr3(int x, int y, int delta)
{
	int i, n;
	if ((x > 0 && x <= FX_ROW) && y < NUM_LOOPS)
	{
		i = fx_gettype(x-1, y);
		i += delta;
		i = (i<0)?0:(i>=nEffectTypes)?nEffectTypes-1:i;
		fx_new(x-1,y,i);
		leave_scr3_box(x,y); enter_scr3_box(x,y);
		set_curr_effect (x-1, y);
		return;
	}
	// effect parameters
	if (y < NUM_LOOPS && x == FX_ROW + 2)
	{
		if (y > 3) y = 3; // deal with extra
		if (curr_effect == NULL) return;
		if (curr_effect->type < 0) return;
		n = effect_types[curr_effect->type].nParms;
		if (y >= n) return;
		i = curr_effect->parms[y];
		i += delta;
		if (i >= effect_types[curr_effect->type].parm_range[y])
			i = effect_types[curr_effect->type].parm_range[y]-1;
		if (i < 0) i = 0;
		curr_effect->parmlink[y]=-1;
		curr_effect->parms[y]=i;
		refresh_efx_parms_scr3();
		return;
	}
	// mouse spinners
	if (y == NUM_LOOPS)
	{
		if (x > 7) x = 7;
		i = mouse_spinner_axis[x]+ delta;
		if (i<NO_AXIS) i = NO_AXIS;
		if (i>MAX_MOUSESPIN) i = MAX_MOUSESPIN;
		mouse_spinner_axis[x] = i;
	}
}

void link_parm_box_scr3(int x, int y, int f)
{
	int n;
	if (x != FX_ROW + 2) return;
	if (y >= NUM_LOOPS) return;
	if (y > 3) y = 3;
	if (curr_effect == NULL) return;
	if (curr_effect->type < 0) return;
	n = effect_types[curr_effect->type].nParms;
	if (y >= n) return;
	curr_effect->parmlink[y] = f - SCANCODE_F1;
	refresh_efx_parms_scr3();
}

void erase_left_stuff_scr3()
{
	int row;
	char zeros[] =	{0,0,0,0,0,0,0,0
				,0,0,0,0
				,0,0,0,0
				,0,0,0,0
				,0,0,0,0};
	for (row = 0; row < NUM_LOOPS*4*8; row++)
		vga_drawscansegment(zeros, (1+FX_LEFT)*8, FX_TOP*8+row, 24);
}


void draw_fx_bmp (int Char, int X, int Y)
{
	int row;
	char zeros[] =	{0,0,0,0
				,0,0,0,0
				,0,0,0,0
				,0,0,0,0};
	for (row = 0; row < 32; row++)
		vga_drawscansegment(fx_bmp+Char*1024+row*32, X, Y+row, 32);
	// clean up next 16 pixels on the right for wire neatness
	for (row = 0; row < 32; row++)
		vga_drawscansegment(zeros, X+32, Y+row, 16);
	
}
// X and Y refer to character position of 2-char Label //
void draw_fx (int Type, int X, int Y, char * Label)
{
	int XP, YP;
	XP = X*8 - 8; YP = Y*8 - 12;
	draw_fx_bmp( Type, XP, YP);
	DrawStr(Label, X, Y, 0xFE);
}

void clear_fx(int Col, int Loop)
{
	int i; static int first = 1;
	static char zeros[FX_WIDTH*8];
	int XP, YP, X, Y;
	X = FX_LEFT + Col*FX_WIDTH + 5;
	Y = FX_TOP + Loop * 4;

	XP = X*8 - 8; YP = Y*8 - 12;
	if (first) 
	{
		first = 0;
		for (i=0;i<FX_WIDTH*8;i++) zeros[i]=0;
	}
	for (i=0;i<32;i++)
		vga_drawscansegment(zeros, XP, YP+i, FX_WIDTH*8);
}



void draw_effect (int Col, int Loop)
{
	int X, Y, C;
	char * txt;
	const effect_stat * es;
	const effect_type * et;
	X = FX_LEFT + Col*FX_WIDTH + 5;
	Y = FX_TOP + Loop * 4;
	es = &fx_layout[Loop][Col];
	if (es->type < 0)
	{
		clear_fx(Col, Loop);
		return;
	}
	et = &effect_types[es->type];
	C = 3 - ( ((et->nIn)-1) + 2*((et->nOut)-1) );
	txt = (char *) et->short_desc;
	draw_fx(C, X, Y, txt);
}

void cursor_effect (int Col, int Loop)
{
	int XP, YP, X, Y;
	X = FX_LEFT + Col*FX_WIDTH + 5;
	Y = FX_TOP + Loop * 4;
	XP = X*8 - 8;  YP = Y*8 - 12;
	box_xy (XP, YP, XP+31, YP+31, 0x0f);
}

void clear_eff_parms_area()
{
	char clearbox[80];
	int i;
	i = 16; clearbox[i] = 0; i--;
	while (i >= 0) {clearbox[i]=' '; i--;}
	for (i=FX_TOP;i<=FX_TOP+NUM_LOOPS*4;i++)
	{
		DrawStr(clearbox, FX_CNTRL_LEFT, i, 0x00);
	}
}

void draw_eff_boxes()
{
	int i, j;
	j = (SCR3_CURY > 3) ? 3 : SCR3_CURY;
	for (i=0;i<4;i++)
		blue_frame_ch(FX_CNTRL_LEFT+2, FX_TOP + 6 + 4*i, FX_CNTRL_LEFT+5, 
				FX_TOP + 6 + 4*i);
		
}



void set_curr_effect (int Col, int Loop)
{
	char * fxtitle;
	char * parmtitle[4];
	int i;
	effect_stat * es; effect_type * et = NULL;
	int type, nparms;
	
	curr_effect = &fx_layout[Loop][Col];
	curr_effect_col = Col;
	curr_effect_loop = Loop;
	clear_eff_parms_area();
	for (i=0;i<4;i++) parmtitle[i]="";
	fxtitle = "";
	es = &fx_layout[Loop][Col];
	curr_effect = es;
	type = es->type;
	if (type >= 0) 
	{
		et = (effect_type *) &effect_types[es->type];
		nparms = et->nParms;
		fxtitle = et->long_desc;
	}	else nparms = 0;
	for (i=0;i<nparms;i++)
	{
		parmtitle[i] = et->parm_desc[i];
	}
	DrawStr(fxtitle, FX_CNTRL_LEFT, FX_TOP, 0xe0);
	for (i=0;i<nparms;i++)
	{
	DrawStr(parmtitle[i], FX_CNTRL_LEFT+1, FX_TOP + 4 + 4 * i, 0xe0);
	}
	draw_eff_boxes();
	refresh_efx_parms_scr3();
}

void refresh_efx_parms_scr3()
{
	effect_type * et;
	char fxstr[8];
	int i, nparms, linked;
	if (curr_effect == NULL) return;
	if (curr_effect->type < 0) return;
	et = (effect_type *) &effect_types[curr_effect->type];
	nparms = et->nParms;
	for (i=0;i<nparms;i++)
	{
		linked = 0;
		if (curr_effect->parmlink[i] >= 0)
		{
			curr_effect->parms[i] = mouse_spinner_value[curr_effect->parmlink[i]];
			linked = 1;
		}
		sprintf(fxstr, "%03d", curr_effect->parms[i]);
		DrawStr(fxstr, FX_CNTRL_LEFT+2, FX_TOP + 6 + 4*i, 
				linked?0xA0:0x80);
				
	}
}

void update_efx_parms_scr3()
{
	int L, C, n;
	effect_stat * es;
	effect_type * et;
	for (L=0;L<NUM_LOOPS;L++)
		for (C=0;C<FX_ROW;C++)
	{
		es = (effect_stat *) & fx_layout[L][C];
		if (es->type == -1) continue;
		et = (effect_type *) & effect_types[es->type];
		for (n=0;n<et->nParms;n++)
		{
			if (es->parmlink[n] >= 0)
				es->parms[n] = mouse_spinner_value[es->parmlink[n]];
			
		}
	}
	
	

}


void set_test_efx_wires_scr3()
{
	loopbus_links[0].is_linked = 1;
	loopbus_links[0].Loop = 2;
	loopbus_links[0].Col = 0;
	loopbus_links[0].Term = 0;
	
	loopbus_links[5].is_linked = 1;
	loopbus_links[5].Loop = 4;
	loopbus_links[5].Col = 1;
	loopbus_links[5].Term = 1;
	
	fx_layout[4][1].link_is[1]=1;
	fx_layout[4][1].link_Loop[1]=6;
	fx_layout[4][1].link_Col[1]=2;
	fx_layout[4][1].link_Term[1]=0;

	fx_layout[6][2].link_is[0]=1;
	fx_layout[6][2].link_Loop[0]=1;
	fx_layout[6][2].link_Col[0]=FX_ROW;
	fx_layout[6][2].link_Term[0]=0;
}

inline pixel in_bus_coords(int inBus)
{
	pixel ret;
	ret.X = (FX_LEFT+1)*8;
	ret.Y = (FX_TOP+4*inBus)*8 + 4;
	return ret;
}

inline pixel out_bus_coords(int outBus)
{
	pixel ret;
	ret.X = FX_LEFT+FX_WIDTH*(1+FX_ROW)-1;
	ret.X *= 8;
	ret.Y = (FX_TOP+4*outBus)*8 + 4;
	return ret;
}

inline pixel fx_in_coords(int Loop, int Col, int Term, int nIn)
{
	pixel ret;
	if (Col >= FX_ROW) return (out_bus_coords(Loop));
	// do upper left corner //
	ret.X = FX_LEFT + Col*FX_WIDTH + 5;
	ret.Y = FX_TOP + Loop * 4;
	ret.X *= 8; ret.Y *= 8;
	ret.X -= 8; ret.Y -= 8;
	// center Y appropriately ....
	if (nIn < 2)
		ret.Y += 12;
	else
		ret.Y += (Term == 0) ? 4 : 20;
	
	return ret;
	
}

inline pixel fx_out_coords(int Loop, int Col, int Term, int nOut)
{
	pixel ret;
	if (Col >= FX_ROW) return (out_bus_coords(Loop));
	// do upper left corner //
	ret.X = FX_LEFT + Col*FX_WIDTH + 5;
	ret.Y = FX_TOP + Loop * 4;
	ret.X *= 8; ret.Y *= 8;
	ret.X += 23; ret.Y -= 8;
	// center Y appropriately ....
	if (nOut < 2)
		ret.Y += 12;
	else
		ret.Y += (Term == 0) ? 4 : 20;
	
	return ret;

}

void draw_efx_wires_scr3()
{
	int i, j, k; pixel a, b; 
	int nIn, nOut;
	int L, C, T;
	int type;
	vga_setcolor(0x0f); // draw in white
	// draw wires from inbus
	for (i=0;i<NUM_LOOPS;i++)
	{
		if (loopbus_links[i].is_linked)
		{
			a = in_bus_coords(i);
			L = loopbus_links[i].Loop;
			C = loopbus_links[i].Col;
			T = loopbus_links[i].Term;
			type = fx_layout[L][C].type;
			nIn = 1;
			if (type >= 0) nIn = effect_types[type].nIn;
			b = fx_in_coords(L, C, T, nIn);
			vga_drawline(a.X, a.Y, b.X, b.Y);
		}
		
	}
	// draw internal wiring
	for (i=0;i<NUM_LOOPS;i++)
		for (j=0;j<FX_ROW;j++)
			for (k=0;k<2;k++)
		if (fx_layout[i][j].link_is[k])
		{
			L = fx_layout[i][j].link_Loop[k];
			C = fx_layout[i][j].link_Col[k];
			T = fx_layout[i][j].link_Term[k];
			nOut = 1; nIn = 1;
			type = fx_layout[L][C].type;
			if (type >= 0) nIn = effect_types[type].nIn;
			type = fx_layout[i][j].type;
			if (type >= 0) nOut = effect_types[type].nOut;
			a = fx_out_coords(i, j, k, nOut);
			b = fx_in_coords(L, C, T, nIn);
			vga_drawline(a.X, a.Y, b.X, b.Y);
		}
		
	
	
	
}

void draw_fx_message(int nMesg)
{
	char * mesg;
	switch (nMesg)
	{
	default:
	case 0:
		mesg = "Press 1 or 2 to select output terminal";
		break;
	case 1:
		mesg = "Press 1 or 2 to select input terminal ";
		break;
	};
	DrawStr(mesg, FX_MESSAGE_X, FX_MESSAGE_Y, 0xb0);	
}

void draw_fx_info()
{
	switch (fx_wire)
	{
	default:
	case 0:
		draw_fx_message(0); break;
	case 1:
		draw_fx_message(1); break;
	};
}

void try_wire_from(int Loop, int Col, int Term)
{
	//	check for bounds	//
	if (Col < -1 || Col >= FX_ROW) return;
	if (Loop >= NUM_LOOPS) return;
	fx_wire = 1;
	fx_wire_col = Col; 
	fx_wire_loop = Loop; 
	fx_wire_term = Term;
	red_mark(Col, Loop, Term);
}

void try_wire_to(int Loop, int Col, int Term)
{
	//	check for bounds	//
	if (Col < 0 || Col > FX_ROW) {fx_wire = 0; return;}
	if (Loop >= NUM_LOOPS) {fx_wire = 0; return;}
	//	don't allow connections from out to in //
	//	of same effect.  lose a little versatility //
	//	here, but also lose a bit of confusion	//
	//	and trouble from key-bounce //
	
	if (Col == fx_wire_col && Loop == fx_wire_loop)
	{
		fx_wire = 0; return;
	}
	
	
	//	make the connection	//
	fx_disconnect_in(Col, Loop, Term); // clean up old stuff
	if (fx_wire_col == -1) // from an inbus?
	{
		loopbus_links[fx_wire_loop].is_linked = 1;
		loopbus_links[fx_wire_loop].Col = Col;
		loopbus_links[fx_wire_loop].Loop = Loop;
		loopbus_links[fx_wire_loop].Term = Term;
	}
	else // from an effect
	{
		fx_layout[fx_wire_loop][fx_wire_col].link_is[fx_wire_term] = 1;
		fx_layout[fx_wire_loop][fx_wire_col].link_Col[fx_wire_term]=Col;
		fx_layout[fx_wire_loop][fx_wire_col].link_Term[fx_wire_term]=Term;
		fx_layout[fx_wire_loop][fx_wire_col].link_Loop[fx_wire_term]=Loop;
	}
	
	fx_wire = 0;
}

void red_mark	(int Col, int Loop, int Term)
{
	int x1, x2, y1, y2;
	pixel p;
	int type;
	int nOut;
	// bus terminals
	if (Col == -1 || Col == FX_ROW)
	{
		p = (Col == -1) ?  in_bus_coords(Loop) : out_bus_coords(Loop);
		x1 = p.X; y1 = p.Y - 4;
		x2 = x1 + 8; y2 = y1 + 8;
		box_xy(x1,y1,x2,y2,0xB);
	}
	// effect terminals
	else
	{
		type = fx_layout[Loop][Col].type;
		if (type >= 0)	nOut = effect_types[type].nOut;
		else		nOut = 1;
		p = fx_out_coords(Loop, Col, Term, nOut);
		x1 = p.X - 4; y1 = p.Y - 4;
		x2 = x1 + 8;  y2 = y1 + 8;
		box_xy(x1,y1,x2,y2,0xB);
	}
	
}
