/////////////////////////////////////////////////////////////////////////////
///	Screen for saving and loading of effect layouts and sample sets /////
/////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgakeyboard.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include "CharMap.h"
#include "loopdata.h"
#include "input.h"
#include "gui.h"
#include "loadlayout.h"

static char title[] = "LOAD/SAVE LAYOUT";

static int button_cursor = 0;

static char * buttons[] = 
{	"CANCEL",
	"LOAD",
	"SAVE EFFECTS",
	"SAVE LOOPS",
	"SAVE ALL"
};

static char save_file_name[128];
const int MAX_SFN = 64;
static const int SFN_X = 10;
static int save_file_cursor;
static int save_file_edit;
static int save_fx;
static int save_loops;

static int totlen = 0;
static const int button_space = 3;
static int button_scr4;
static const int FILES_TOP = 8;
static const int FILES_SHOWN = 58 - 8;

static char working_dir[1024];
static char top_file_name[1024];

static int top_file_in_dir = 0;

static char clear_dir[81];

static void get_button_scr4(int button, int * left, int * length)
{
	int i; int lft, len;
	lft = 0;
	for (i=0;i<button;i++)
	{
		lft += strlen(buttons[i]) + button_space;
	}
	len = strlen(buttons[i]);
	lft += 40-totlen/2;
	*left = lft; *length = len;
}

static void leave_button_scr4(int button)
{
	int lft, len;
	get_button_scr4(button, &lft, &len);
	blue_frame_ch(lft, 4, lft+len, 4);
}

static void enter_button_scr4(int button)
{
	int lft, len;
	get_button_scr4(button, &lft, &len);
	active_frame_ch(lft, 4, lft+len, 4);

}

static void erase_directory_listing()
{
	char clear_listing[79];
	int i;
	clear_listing[78]=0;
	vga_waitretrace();
	for (i=0;i<78;i++) clear_listing[i]=' ';
	for (i=FILES_TOP; i<59; i++) DrawStr(clear_listing, 1, i, 0x00);
}


static void draw_directory()
{
	DIR * the_dir;
	struct dirent * dir_entry = NULL;
	char * dir_name_line;
	static int first_time = 1;
	char * get_dir_display;
	int len_dir, i, y;
	long int dir_pos;
	getcwd(working_dir, 1024);
	the_dir = opendir(working_dir);
	// get either pathname for dir or right 80 chars //
	// draw it centered on top of screen 		 //
	if (first_time == 1)
	{
		first_time = 0;
		clear_dir[80]=0;
		for (i=0;i<80;i++) clear_dir[i]=' ';
	}
	len_dir = strlen(working_dir);
	if (len_dir < 80) get_dir_display = working_dir;
	else
	{
		get_dir_display = working_dir + len_dir;
		get_dir_display -= 80;
	}
	DrawStr(clear_dir, 0, FILES_TOP-2, 0x00);
	DrawStr(get_dir_display, 40-strlen(get_dir_display)/2,
				FILES_TOP-2, 0xb0);
	erase_directory_listing();
	// now draw all the directory entries //
	if (the_dir == NULL) return;
	// get the number of entries in dir //
	// if there are less entries then top_file_in_dir //
	// set top_file_in_dir to last file//
	dir_pos = telldir(the_dir);
	i = 0;
	while(1)
	{	
		dir_entry = readdir(the_dir);   
		if (dir_entry == NULL) break;
		i++;
	}
	if (i <= top_file_in_dir) top_file_in_dir = i-1;
	seekdir(the_dir, dir_pos);
	// eat excess entries at top of dir //
	i = top_file_in_dir;
	while (i > 0) {dir_entry = readdir(the_dir); i--;}
	// get dir strings until end or screen is full //
	i = FILES_SHOWN;
	y = FILES_TOP;
	while (i > 0)
	{
		dir_entry = readdir(the_dir);
		// record top name //
		if (y == FILES_TOP)
		{
			if (dir_entry != NULL)
			strcpy(top_file_name, dir_entry->d_name);
			else	top_file_name[0]=0;
		}
		if (dir_entry == NULL) break;
		dir_name_line = dir_entry->d_name;
		len_dir = strlen(dir_name_line);
		if (len_dir > 78) dir_name_line += len_dir - 78;		
		DrawStr(dir_name_line, 2, y, (y==FILES_TOP)?0xf0:0x80);
		y++; i--;
	}
	closedir (the_dir);
}

static void draw_save_file_name()
{
	DrawStr(clear_dir, 0, FILES_TOP-2, 0x00);
	DrawStr("FILENAME:", 1, FILES_TOP-2, 0x90);	
	DrawStr(save_file_name, SFN_X, FILES_TOP-2, 0x90);
	// now draw cursor
	if (save_file_cursor > strlen(save_file_name)) save_file_cursor = strlen(save_file_name);
	if (save_file_cursor < 0) save_file_cursor = 0;
	// if cursor is in string, do reverse-video thing
	if (save_file_cursor < strlen(save_file_name))
		DrawAscChar(save_file_name[save_file_cursor],  SFN_X + save_file_cursor,
			FILES_TOP-2, 0x09);
	else
		DrawAscChar(' ', SFN_X + save_file_cursor,
			FILES_TOP-2, 0x09);

	 
}


void draw_static_screen4()
{
	int i, x;
	DrawStr(title, 40-strlen(title)/2 , 1, 0x80);
	blue_frame_ch(40-strlen(title)/2, 1, 40+strlen(title)/2, 1); 
	totlen = 0;
	save_file_edit = 0;
	button_scr4 = 1;
	button_cursor = 0;
	for (i=0;i<5;i++)
		totlen += strlen(buttons[i]) + button_space;
	x = 40 - totlen/2;
	for (i=0;i<5;i++)
	{
		DrawStr(buttons[i], x, 4, 0x80);
		if (i != 1)
			blue_frame_ch(x, 4, x+strlen(buttons[i]), 4);
		else
			active_frame_ch(x, 4, x+strlen(buttons[i]), 4);
		x += strlen(buttons[i]) + button_space;
	}
	
	blue_frame_ch(1, FILES_TOP, 78, 58);	
	draw_directory();
}

static char text_entered()
{
	int i;
	char row1[] = "QWERTYUIOP";
	char row2[] = "ASDFGHJKL";
	char row3[] = "ZXCVBNM";
	int to_low = 'a' - 'A';
	int shift;
	int alf;
	shift = (is_pushed(SCANCODE_RIGHTSHIFT) || is_pushed(SCANCODE_LEFTSHIFT)); 
	for (i=SCANCODE_1; i <= SCANCODE_0; i++)
	{
		if (is_pushed(i))
		{
			if (i == SCANCODE_0) return '0';
			else return (i+'1'-SCANCODE_1);
		}
		
	}
	for (i=SCANCODE_Q; i <= SCANCODE_P; i++)
		if (is_pushed(i))
		{	
			alf = row1[i-SCANCODE_Q];
			return (shift)?alf:alf+to_low;
		}
	
	for (i=SCANCODE_A; i <= SCANCODE_L; i++)
		if (is_pushed(i))
		{
			alf = row2[i-SCANCODE_A];
			return (shift)?alf:alf+to_low;
		}
	
	for (i=SCANCODE_Z; i <= SCANCODE_M; i++)
		if (is_pushed(i))
		{
			alf = row3[i-SCANCODE_Z];
			return (shift)?alf:alf+to_low;
		}
		
	
	if (is_pushed(SCANCODE_PERIOD)) return '.';
	if (is_pushed(SCANCODE_MINUS))
	{
		return (shift)?'_':'-';
	}
	
	return 0;
}

static void handle_textentry()
{
	char entry; int i; char * save_message;
	slow_keys(1);
	if (is_pushed(SCANCODE_ESCAPE)) 
	{
		save_file_edit = 0; 
		draw_directory();
		slow_keys(0);
		return;
	}
	if (is_pushed(SCANCODE_ENTER) && save_file_name[0] != 0)
	{
		save_file_edit = 0;
		slow_keys(0);
		save_message = save_layout(save_file_name, save_loops, save_fx);
		DrawStr(clear_dir, 0, FILES_TOP-2, 0x00);
		DrawStr(save_message, 40-strlen(save_message)/2,
				FILES_TOP-2, 0xb0);
		return;
	}
	
	// was a text character entered? insert it into text
	if ((entry = text_entered()) != 0 && strlen(save_file_name) < MAX_SFN)
	{
		// shift over right part of save name
		save_file_name[strlen(save_file_name)+1]=0;
		for (i = strlen(save_file_name); i > save_file_cursor; i--)
			save_file_name[i] = save_file_name[i-1];
		save_file_name[save_file_cursor]=entry;
		save_file_cursor++;
		draw_save_file_name();
		return;
	}
	// was backspace entered?
	if (is_pushed(SCANCODE_BACKSPACE) && save_file_cursor != 0)
	{
		for (i=save_file_cursor-1; save_file_name[i]!=0; i++)
			save_file_name[i] = save_file_name[i+1];
		save_file_cursor--;
		draw_save_file_name();
		return;
	}
	// cursor movement
	if (is_pushed(SCANCODE_CURSORBLOCKRIGHT))
	{
		save_file_cursor++; draw_save_file_name(); return;
	}
	if (is_pushed(SCANCODE_CURSORBLOCKLEFT) && save_file_cursor != 0)
	{
		save_file_cursor--; draw_save_file_name(); return;
	}
	if (is_pushed(SCANCODE_HOME))
	{
		save_file_cursor=0; draw_save_file_name(); return;
	}
	if (is_pushed(SCANCODE_END))
	{
		save_file_cursor=strlen(save_file_name); draw_save_file_name(); return;
	}
}


void handle_keyboard_screen4()
{
	int old_button;
	struct stat stbuf;
	char * status_message;
	if (save_file_edit) {handle_textentry(); return;}
	old_button = button_scr4;
	if (is_pushed(SCANCODE_CURSORBLOCKLEFT)) button_scr4--;
	if (is_pushed(SCANCODE_CURSORBLOCKRIGHT)) button_scr4++;	
	if (button_scr4 < 0) button_scr4 = 0;
	if (button_scr4 > 4) button_scr4 = 4;
	if (old_button != button_scr4)
	{
		leave_button_scr4(old_button);
		enter_button_scr4(button_scr4);
	}
	if (is_pushed(SCANCODE_ESCAPE)) {switch_screen(1); return;}
	if (is_pushed(SCANCODE_SPACE))
	{
		// if cursor is on a directory, switch to it
		if (0 != stat(top_file_name, &stbuf) ) return;
		if (stbuf.st_mode & S_IFDIR)
		{
			chdir (top_file_name);
			top_file_in_dir=0;
			draw_directory();
			return;
		}
	}
	if (is_pushed(SCANCODE_ENTER))
	{
		switch (button_scr4)
		{
		case 0:
			switch_screen(1); return; break;
		case 1:
			// if on directory, switch to it,
			// otherwise load the file
			
			if (0 != stat(top_file_name, &stbuf) ) return;
			if (stbuf.st_mode & S_IFDIR)
			{
				chdir (top_file_name);
				top_file_in_dir=0;
				draw_directory();
				return;
			}
			status_message = load_layout(top_file_name);
			DrawStr(clear_dir, 0, FILES_TOP-2, 0x00);
			DrawStr(status_message, 40-strlen(status_message)/2,
				FILES_TOP-2, 0xb0);
			return;
		case 2:
		case 3:
		case 4:
			save_fx = save_loops = 0;
			if (button_scr4 == 2) save_fx = 1;
			if (button_scr4 == 3) save_loops = 1;
			if (button_scr4 == 4) save_fx=save_loops=1;
			save_file_name[0]=0;
			save_file_cursor = 0;
			draw_save_file_name();
			save_file_edit = 1;
			return;
			
		};
	}
	
	if (is_pushed(SCANCODE_CURSORBLOCKUP))
		if (top_file_in_dir>0)
		{ top_file_in_dir--; draw_directory();}
	if (is_pushed(SCANCODE_CURSORBLOCKDOWN))
		{ top_file_in_dir++; draw_directory();}
	if (is_pushed(SCANCODE_PAGEUP))
	{
		top_file_in_dir -= 10; 
		if (top_file_in_dir < 0) top_file_in_dir = 0;
		draw_directory();
	}
	if (is_pushed(SCANCODE_PAGEDOWN))
		{ top_file_in_dir += 10; draw_directory();}
	
}

